<template>
  <v-flex xs12 sm6>
    <v-card>
      <v-card-title primary-title>
        <div>
          <h3 class="headline mb-0">Spectrum</h3>
        </div>
      </v-card-title>
      <v-responsive>
        <div ref="plot" ></div>
      </v-responsive>
      <!-- <v-card-actions>
        <v-btn flat color="orange">Share</v-btn>
        <v-btn flat color="orange">Explore</v-btn>
      </v-card-actions> -->
    </v-card>
  </v-flex>
</template>

<script>
const axios = require('axios')
import Plotly from 'plotly.js-dist'
import plotly_layout from '~/assets/plotly_layout.json'

export default {
  name: 'Spectrum',
  data() {
    return {
      info: null
    }
  },
  methods: {
    load_spectrum() {
      function range(i) {
        return i ? range(i - 1).concat(i) : []
      }

      var config = {
        headers: {
          'Content-Type': 'application/json',
          'Cache-Control': 'no-cache'
        }
      }
      axios.get('/data/spec.json').then(response => (this.info = response), config)
    }
  },
  mounted() {
    this.$watch('info', function(newVal, oldVal) {
      var _data = this.info.data.spectrum_00[0]
      var _x = Array.from(Array(_data.length), (x, i) => i)
      var trace = {
        x: _x,
        y: _data,
        type: 'bar'
      }
      let layout = {
        ...plotly_layout,
        ...{
          xaxis: {
            title: 'Energy [A.U.]',
            range: [0, 1024]
          },
          yaxis: {
            title: 'Counts [#]',
            type: 'log',
            autorange: true
          },
          // margin: {
          //   l: 80,
          //   r: 20,
          //   b: 30,
          //   t: 30,
          //   pad: 0
          // }
        }
      }
      var plot_data = [trace]
      Plotly.newPlot(this.$refs.plot, plot_data, layout)
    })
    this.load_spectrum()
  }
}
</script>
